Subject: Re: [PATCH 3/8] staging: wfx: standardize the error when vif does not exist

From: Jérôme Pouiller <[email-masked]>
Date: Sat, 10 Oct 2020 14:22:13 +0200

On Friday 9 October 2020 20:52:47 CEST Kalle Valo wrote:
> Jerome Pouiller <[email-masked]> writes:
> 
> > From: Jérôme Pouiller <[email-masked]>
> >
> > Smatch complains:
> >
> >    drivers/staging/wfx/hif_rx.c:177 hif_scan_complete_indication() warn: potential NULL parameter dereference 'wvif'
> >    drivers/staging/wfx/data_tx.c:576 wfx_flush() warn: potential NULL parameter dereference 'wvif'
> >
> > Indeed, if the vif id returned by the device does not exist anymore,
> > wdev_to_wvif() could return NULL.
> >
> > In add, the error is not handled uniformly in the code, sometime a
> > WARN() is displayed but code continue, sometime a dev_warn() is
> > displayed, sometime it is just not tested, ...
> >
> > This patch standardize that.
> >
> > Reported-by: Dan Carpenter <[email-masked]>
> > Signed-off-by: Jérôme Pouiller <[email-masked]>
> > ---
> >  drivers/staging/wfx/data_tx.c |  5 ++++-
> >  drivers/staging/wfx/hif_rx.c  | 34 ++++++++++++++++++++++++----------
> >  drivers/staging/wfx/sta.c     |  4 ++++
> >  3 files changed, 32 insertions(+), 11 deletions(-)
> >
> > diff --git a/drivers/staging/wfx/data_tx.c b/drivers/staging/wfx/data_tx.c
> > index b4d5dd3d2d23..8db0be08daf8 100644
> > --- a/drivers/staging/wfx/data_tx.c
> > +++ b/drivers/staging/wfx/data_tx.c
> > @@ -431,7 +431,10 @@ static void wfx_skb_dtor(struct wfx_vif *wvif, struct sk_buff *skb)
> >                             sizeof(struct hif_req_tx) +
> >                             req->fc_offset;
> >
> > -     WARN_ON(!wvif);
> > +     if (!wvif) {
> > +             pr_warn("%s: vif associated with the skb does not exist anymore\n", __func__);
> > +             return;
> > +     }
> 
> I'm not really a fan of using function names in warning or error
> messages as it clutters the log. In debug messages I think they are ok.

In the initial code, I used WARN() that far more clutters the log (I
have stated that a backtrace won't provide any useful information, so
pr_warn() was better suited).

In add, in my mind, these warnings are debug messages. If they appears,
the user should probably report a bug.

Finally, in this patch, I use the same message several times (ok, not
this particular one). So the function name is a way to differentiate
them.

-- 
Jérôme Pouiller